game = {}
function game.update(dt)
		
-- Prüfe Kollisionen
-- Bewege Objekte und entferne Objekte
	local loeschObjekte = {}
	for k,v in ipairs(Spriteliste) do
		if v.dead then table.insert(loeschObjekte,k)
		else v:move(dt) end
	end
	table.sort(loeschObjekte, function (a,b) return (a > b) end)
	for i, v in ipairs(loeschObjekte) do table.remove(Spriteliste,v) end
	
-- Berechne Zeichenkoordinaten für Objekte
	for k,v in pairs(Spriteliste) do
		v:updateCoordinates()
	end
-- Sortiere nach "tiefe"	
	table.sort(Spriteliste, function (a,b) return (a.z < b.z) end)
	
	-- Setze Weltkoordinaten der Kamera
	camwx = player.wx
	camwy = player.wy
	camwz = camwz + 0.02*(camwzAim-camwz)

end

function game.draw()
	camx = 64 * (camwy-camwx)
	camy = 32 * (camwx+camwy) - 24*camwz
	love.graphics.setStencil()
	love.graphics.push()
	love.graphics.translate(math.floor(400-camx),math.floor(300-camy))
	
	-- Karte zeichnen
	love.graphics.draw(mapPicture,-64*#map.x,-24*mapMaxZ)
	
	--love.graphics.setStencil(stencils[currentStencil])
	--love.graphics.polygon('fill', -1000,-300,1000,-300,1000,1000,-1000,1000,-1000,-300)
	--love.graphics.setStencil()
	--for k,v in pairs(Stripes) do
	--	love.graphics.draw(v,-64*#map.x,32*k-24*mapMaxZ-113)
	--end
	-- Objekte sortieren
	-- Objekte im Bild zeichnen
	love.graphics.setInvertedStencil(stencils[stencilNumber])	
	for k,v in pairs(Spriteliste) do
		v:draw()
	end
	love.graphics.pop()
	love.graphics.print('Framerate = ' .. love.timer.getFPS(),10,10)
--	love.graphics.print('Current Stencil: ' .. currentStencil,10,30)
end

function game.keypressed(key)
	if key == "escape" then
		love.event.push("quit")
	end	
	if key == "a" then
		player:hopp()
	end
	if key == "i" then
		local ball = Ball:New({wx = 3, wy = 3.5,wz = 4})
		table.insert(Spriteliste, ball)
	end
	if key == "w" then
		map.z[math.floor(player.wx)+1][math.floor(player.wy)+1] =
			math.min(map.z[math.floor(player.wx)+1][math.floor(player.wy)+1] + 1,mapMaxZ)
		mapPicture = {}
		mapPicture = drawMapCanvas()
	end
	if key == "s" then
		map.z[math.floor(player.wx)+1][math.floor(player.wy)+1] =
			math.max(map.z[math.floor(player.wx)+1][math.floor(player.wy)+1] - 1,0)
		mapPicture = {}
		mapPicture = drawMapCanvas()
	end
	if key == "e" then
		map.tile[math.floor(player.wx)+1][math.floor(player.wy)+1] =
			math.min(map.tile[math.floor(player.wx)+1][math.floor(player.wy)+1] + 1,19)
		mapPicture = {}
		mapPicture = drawMapCanvas()
	end
	if key == "d" then
		map.tile[math.floor(player.wx)+1][math.floor(player.wy)+1] =
			math.max(map.tile[math.floor(player.wx)+1][math.floor(player.wy)+1] - 1,1)
		mapPicture = {}
		mapPicture = drawMapCanvas()
	end	
	if key == "t" then
		currentStencil = currentStencil+1
	end
	if key == "g" then
		currentStencil = math.max(2,currentStencil-1)
	end	
	
	
end
