function love.load()
	require "game"
	require "main"
	require "menu"
	require "map"

	local mapsize = 200
	isoxx = -32
	isoxy = 16
	isoyx = 32
	isoyy = 16
	love.graphics.setDefaultImageFilter("nearest", "nearest")
	kacheln = love.graphics.newImage("kacheln.png")
	pfeil = love.graphics.newImage("pfeil.png")
	scrollx, scrolly = -100,0
	zmap = new_zmap(mapsize,mapsize)
	map = zmap_to_map(zmap)
	map.maxz = 3
	kachel = {}
	for i = 1,17 do
	  kachel[i] = love.graphics.newCanvas(64,55)
		love.graphics.setCanvas(kachel[i])
		love.graphics.draw(kacheln,-64*(i-1),0)
	end
	love.graphics.setCanvas()
	
	windowSizeX = 800
	windowSizeY = 600
	player ={x = 1, y = 1}
end

function love.update(dt)
	speed = 10
  if love.keyboard.isDown("left")  then player.x = player.x+speed*dt player.y = player.y-speed*dt end
  if love.keyboard.isDown("right") then player.x = player.x-speed*dt player.y = player.y+speed*dt end
  if love.keyboard.isDown("up")    then player.x = player.x-speed*dt player.y = player.y-speed*dt end
  if love.keyboard.isDown("down")  then player.x = player.x+speed*dt player.y = player.y+speed*dt end
 --[[ if love.keyboard.isDown("left")  then scrollx = scrollx-200*dt end
  if love.keyboard.isDown("right")  then scrollx = scrollx+200*dt end
  if love.keyboard.isDown("up")  then scrolly = scrolly-100*dt end
  if love.keyboard.isDown("down")  then scrolly = scrolly+100*dt end]]--
end

function love.draw()
--love.graphics.scale(2,2)
player.z = zFromMap(player.x,player.y)
player.X = 32*(player.y-player.x)+32
player.Y = 16*(player.x+player.y)-11*player.z+55
scrollx = scrollx*0.9+0.1*(player.X-400)
scrolly = scrolly*0.9+0.1*(player.Y-300)

love.graphics.push()
love.graphics.translate(math.floor(-scrollx),math.floor(-scrolly))



-- nur die Zeichnen, die benötigt werden
-- Iteriere über spalten
mapxmax = #map.x
mapymax = #map.x[1]
tileScrollX = math.floor(scrollx/32)
tileScrollY = math.floor((scrolly-55)/16)

local tilecount = 0
xmin = math.max(math.floor(0.5*(tileScrollY-tileScrollX))-12,1)
xmax = math.min(math.floor(0.5*(tileScrollY-tileScrollX)+map.maxz*11/16)+19,mapxmax)
for x =xmin,xmax do
	ymin = math.max(x+tileScrollX-1,tileScrollY-x+1,1)
	ymax = math.min(x+25+tileScrollX,tileScrollY+math.floor(11/16*map.maxz)+38-x,mapymax)
	if ymin<=ymax then
		for y = ymin,ymax do
			love.graphics.draw(kachel[map.tile[x][y] ],map.x[x][y],map.y[x][y]-11*map.z[x][y])
			tilecount=tilecount+1
	
		end
	end
end
-- Spieler zeichnen
love.graphics.draw(pfeil,player.X,player.Y)

love.graphics.pop()
love.graphics.print(love.timer.getFPS( ),10,10)
love.graphics.print("Anzahl der Tiles: "..tilecount,10,35)
end




function love.keypressed(key)
	if key == "escape" then
		love.event.push("quit")
	end
	if key == " " then
	raise(math.floor(player.x+1),math.floor(player.y+1))
	map = zmap_to_map(zmap)
	end
end




