function drawTile(x,y)
	print('drawTile mit x = '..x..' und y = ' .. y)
	love.graphics.draw(kachel[map.tile[x][y]],map.x[x][y]-64,map.y[x][y]-24*map.z[x][y]-113+24*mapMaxZ-240)
	for i = 1,map.z[x][y] do
		love.graphics.draw(wand,map.x[x][y]-64,map.y[x][y]-24*(map.z[x][y]-i+1)+24*mapMaxZ-33-240)
	end
end

function drawStencils()
	local stencils = {}
	local xlength = #map.x
	local ylength = #map.x[1]
	
	for i = 2,xlength+ylength do
		local drawInside = function()
			for x in pairs(map.x) do
				for y in pairs(map.x[x]) do
					if x+y>=i then
						local vertices =
							{map.x[x][y]-64,map.y[x][y]-24*map.z[x][y]+213,
							 map.x[x][y]-64,map.y[x][y]-24*map.z[x][y]-33,
							 map.x[x][y]   ,map.y[x][y]-24*map.z[x][y]-33-32,
							 map.x[x][y]+64,map.y[x][y]-24*map.z[x][y]-33,
							 map.x[x][y]+64,map.y[x][y]-24*map.z[x][y]+213
							 }
						love.graphics.polygon('fill',vertices)
						
						--			love.graphics.draw(kachel[map.tile[x][y]],map.x[x][y]-64+xlength*64,24*(mapMaxZ-map.z[x][y]))
			--for i = 1,map.z[x][y] do
			--	love.graphics.draw(wand,map.x[x][y]-64+xlength*64,24*(mapMaxZ-map.z[x][y]+i-1)+81)
			--end
					end
				end
			end

		end
		-- Erzeuge Stencil
		stencils[i] = love.graphics.newStencil(drawInside)
	end
	love.graphics.setCanvas()
	return stencils
end

function drawMapStripes()
	local MapStripes = {}
	local xlength = #map.x
	local ylength = #map.x[1]
	-- Erzeuge Streifen
	for i = 2,xlength+ylength do
		MapStripes[i] = love.graphics.newCanvas(64*(xlength+ylength+1),113+24*mapMaxZ+1)
	end
	-- Fülle Streifen
	for x in pairs(map.x) do
		for y in pairs(map.x[x]) do
			i = x+y
			love.graphics.setCanvas(MapStripes[i])
			love.graphics.draw(kachel[map.tile[x][y]],map.x[x][y]-64+xlength*64,24*(mapMaxZ-map.z[x][y]))
			for i = 1,map.z[x][y] do
				love.graphics.draw(wand,map.x[x][y]-64+xlength*64,24*(mapMaxZ-map.z[x][y]+i-1)+81)
			end
		end
	end
	love.graphics.setCanvas()
	return MapStripes
end
function drawMapCanvas()
	local xlength = #map.x
	local ylength = #map.x[1]
	local leinwand = love.graphics.newCanvas(64*(xlength+ylength+1),32*(xlength+ylength+1)+24*mapMaxZ)
	love.graphics.setCanvas(leinwand)
	love.graphics.push()
	love.graphics.translate(xlength*64,0)
	for x in pairs(map.x) do
		for y in pairs(map.x[x]) do
			love.graphics.draw(kachel[map.tile[x][y]],map.x[x][y]-64,map.y[x][y]-24*map.z[x][y]-113+24*mapMaxZ)
			for i = 1,map.z[x][y] do
				love.graphics.draw(wand,map.x[x][y]-64,map.y[x][y]-24*(map.z[x][y]-i+1)+24*mapMaxZ-33)
			end
		end 
	end
	love.graphics.pop()
	love.graphics.setCanvas()
	return leinwand
end

function new_zmap(sizex,sizey)
	map = {}
	for x=1,sizex do
		map[x] = {}
		for y = 1,sizey do
			map[x][y] = 2--math.max(0,math.random(-1,1))
		end
	end
	map[6][4] = 5
	map[2][2] = 4
	return map
end

function mapRaise(x,y)
-- Das hier läuft zur Zeit überhauptnicht!!

	xSize = #zmap
	ySize = #zmap[1]
	if zmap[x][y] then zmap[x][y] = zmap[x][y] + 1 end
	
	local mapNeedsFix = true;
	while mapNeedsFix do
	--for zaehler = 1,10 do
		print('** Neuer Durchlauf **')
		mapNeedsFix = false
		for i = 1,15 do
			for j = 1,15 do
				print('i = ' .. i .. ', j = ' .. j)
				if i > 1 and zmap[i-1][j] < zmap[i][j] then zmap[i-1][j] = zmap[i][j]-1 mapNeedsFix = true print('Problem bei '.. i-1 ..' '.. j) end
				if i < xSize-1 and zmap[i+1][j] < zmap[i][j] then zmap[i+1][j] = zmap[i][j]-1 mapNeedsFix = true print('Problem bei ' ..i+1 ..' '.. j) end
				if j < ySize-1 and zmap[i][j+1] < zmap[i][j] then zmap[i][j+1] = zmap[i][j]-1 mapNeedsFix = true print('Problem bei '..i ..' '.. j+1) end
				if j > 1 and zmap[i][j-1] < zmap[i][j] then zmap[i][j-1] = zmap[i][j]-1 mapNeedsFix = true print('Problem bei '..i ..' '.. j-1) end				
			end
		end
	print(mapNeedsFix)
	end
	
end

function mapLower(zmap,x,y)
	if zmap[x][y]  then		
		zmap[x][y] = zmap[x][y] -1
		if zmap[x-1][y] and zmap[x-1][y] < zmap[x][y]-1 then mapLower(zmap,x-1,y) end
		if zmap[x+1][y] and zmap[x+1][y] < zmap[x][y]-1 then mapLower(zmap,x+1,y) end
		if zmap[x][y-1] and zmap[x][y-1] < zmap[x][y]-1 then mapLower(zmap,x,y-1) end
		if zmap[x][y+1] and zmap[x][y+1] < zmap[x][y]-1 then mapLower(zmap,x,y+1) end
	end
end

function zmap_to_map(zmap)
	map.tile = {}
	map.z = {}
	map.y = {}
	map.x = {}
	for x =1,#zmap-1 do
		map.tile[x] = {}
		map.z[x] = {}
		map.y[x] = {}
		map.x[x] = {}
		for y = 1,#zmap[x]-1 do
			-- Bestimme Lokale Unterschiede
			local oben = 0
			local links = zmap[x+1][y]-zmap[x][y]
			local rechts = zmap[x][y+1]-zmap[x][y]
			local unten = zmap[x+1][y+1]-zmap[x][y]
			-- Berechnet tile.x, tile.y, tile.z ausgehend von der "unteren" Ecke
			map.x[x][y] = -64*x+64*y
			map.y[x][y] = 32*x+32*y
			map.z[x][y] = zmap[x+1][y+1]
			-- Komplizierte Case-unterscheidung zur bestimmung der Kachel
			if links == 0 and rechts == 0 and unten == 0 then map.tile[x][y] = 1
			elseif links == 0 and rechts == 0 and unten == 1 then map.tile[x][y] = 4 map.z[x][y] = map.z[x][y]-1
			elseif links == 0 and rechts == 0 and unten == -1 then map.tile[x][y] = 10
			elseif links == 0 and rechts == 1 and unten == 0 then map.tile[x][y] = 5
			elseif links == 0 and rechts == 1 and unten == 1 then map.tile[x][y] = 8 map.z[x][y] = map.z[x][y]-1
			elseif links == 0 and rechts == -1 and unten == -1 then map.tile[x][y] = 6
			elseif links == 0 and rechts == -1 and unten == 0 then map.tile[x][y] = 11 map.z[x][y] = map.z[x][y]-1

			elseif links == 1 and rechts == 0 and unten == 0 then map.tile[x][y] = 3
			elseif links == 1 and rechts == 1 and unten == 0 then map.tile[x][y] = 15
			elseif links == 1 and rechts == 1 and unten == 1 then map.tile[x][y] = 12 map.z[x][y] = map.z[x][y]-1 
			elseif links == 1 and rechts == 0 and unten == 1 then map.tile[x][y] = 9 map.z[x][y] = map.z[x][y]-1
			elseif links == 1 and rechts == -1 and unten == 0 then map.tile[x][y] = 17 map.z[x][y] = map.z[x][y]-1
			elseif links == 1 and rechts == 1 and unten == 2 then map.tile[x][y] = 18 map.z[x][y] = map.z[x][y]-2

			elseif links == -1 and rechts == 0 and unten == 0 then map.tile[x][y] = 13 map.z[x][y] = map.z[x][y]-1
			elseif links == -1 and rechts == 0 and unten == -1 then map.tile[x][y] = 7
			elseif links == -1 and rechts == -1 and unten == 0 then map.tile[x][y] = 14 map.z[x][y] = map.z[x][y]-1
			elseif links == -1 and rechts == -1 and unten == -1 then map.tile[x][y] = 2
			elseif links == -1 and rechts == 1 and unten == 0 then map.tile[x][y] = 16 map.z[x][y] = map.z[x][y]-1
			elseif links == -1 and rechts == -1 and unten == -2 then map.tile[x][y] = 19
			else map.tile[x][y] = 1
			end
		end
	end
	return map
end

function zFromMap(x,y)
	if x<=0 or y<=0 then return 0 end
	if x>= #map.x or y>=#map.x[1] then return 0 end
	truncX = math.floor(x)+1
	truncY = math.floor(y)+1
	x = x-truncX+1
	y = y-truncY+1
	if map.tile[truncX][truncY] == 1 then return map.z[truncX][truncY]
	elseif map.tile[truncX][truncY] == 2 then return map.z[truncX][truncY] + math.max(0,1-x-y)
	elseif map.tile[truncX][truncY] == 3 then return map.z[truncX][truncY] + math.max(0,x-y)
	elseif map.tile[truncX][truncY] == 4 then return map.z[truncX][truncY] + math.max(0,x+y-1)
	elseif map.tile[truncX][truncY] == 5 then return map.z[truncX][truncY] + math.max(0,y-x)
	elseif map.tile[truncX][truncY] == 6 then return map.z[truncX][truncY] + 1-y
	elseif map.tile[truncX][truncY] == 7 then return map.z[truncX][truncY] + 1-x
	elseif map.tile[truncX][truncY] == 8 then return map.z[truncX][truncY] + y
	elseif map.tile[truncX][truncY] == 9 then return map.z[truncX][truncY] + x
	elseif map.tile[truncX][truncY] == 10 then return map.z[truncX][truncY] + math.min(1,2-x-y)
	elseif map.tile[truncX][truncY] == 11 then return map.z[truncX][truncY] + math.min(1,x-y+1)
	elseif map.tile[truncX][truncY] == 12 then return map.z[truncX][truncY] + math.min(1,x+y)
	elseif map.tile[truncX][truncY] == 13 then return map.z[truncX][truncY] + math.min(1,y-x+1)
	elseif map.tile[truncX][truncY] == 14 then return map.z[truncX][truncY] + 1+ math.min(x-y,y-x)
	elseif map.tile[truncX][truncY] == 15 then return map.z[truncX][truncY] + math.min(x+y,2-x-y)
	elseif map.tile[truncX][truncY] == 16 then return map.z[truncX][truncY] - x+y + 1
	elseif map.tile[truncX][truncY] == 17 then return map.z[truncX][truncY] + x-y + 1
	elseif map.tile[truncX][truncY] == 18 then return map.z[truncX][truncY] + x+y
	elseif map.tile[truncX][truncY] == 19 then return map.z[truncX][truncY] - x-y + 2
	end
end

function gradientFromMap(x,y)
-- Gebe richtung der Steigung aus
-- Vektor zeigt immer Bergab
	if x<=0 or y<=0 then return {0,0} end
	if x>= #map.x or y>=#map.x[1] then return {0,0} end
	-- Ab hier ist truncXY die ganzzahlige Zelle und x,y die Koordinate in
	-- der Zelle (zwischen 0 und 1)
	truncX = math.floor(x)+1
	truncY = math.floor(y)+1
	x = x-truncX+1
	y = y-truncY+1
	local tileHere = map.tile[truncX][truncY]
	local zHere = map.z[truncX][truncY]
	-- eindeutige Fälle
	if tileHere == 1 then return {0,0}
	elseif tileHere ==  6 then return {0,1}
	elseif tileHere ==  7 then return {1,0}
	elseif tileHere ==  8 then return {0,-1}
	elseif tileHere ==  9 then return {-1,0}
	elseif tileHere == 16 then return {1,-1}
	elseif tileHere == 17 then return {-1,1}
	elseif tileHere == 18 then return {-1,-1}
	elseif tileHere == 19 then return {1,1}
	end
	
	if x+y < 1 then -- obere Hälfte
		if tileHere == 2 then return {1,1}
		elseif tileHere == 4 then return {0,0}
		elseif tileHere == 10 then return {0,0}
		elseif tileHere == 12 then return {-1,-1}
		elseif tileHere == 15 then return {-1,-1}
		end
	else -- untere Hälfte
		if tileHere == 2 then return {0,0}
		elseif tileHere == 4 then return {-1,-1}
		elseif tileHere == 10 then return {1,1}
		elseif tileHere == 12 then return {0,0}
		elseif tileHere == 15 then return {1,1}
		end
	end
	
	if x > y then -- linke Hälfte
		if tileHere == 3 then return {-1,1}
		elseif tileHere == 5 then return {0,0}
		elseif tileHere == 11 then return {0,0}
		elseif tileHere == 13 then return {1,-1}
		elseif tileHere == 14 then return {1,-1}
		end
	else -- rechte Hälfte
		if tileHere == 3 then return {0,0}
		elseif tileHere == 5 then return {1,-1}
		elseif tileHere == 11 then return {-1,1}
		elseif tileHere == 13 then return {0,0}
		elseif tileHere == 14 then return {-1,1}
		end
	end
print('Fehler, keine Steigung gefunden')
return {0,0}
	

end
