Sprite = {
	wx = 0, wy = 0, wz = 0,
	x  = 0,  y = 0,  z = 0,
	ox = 0, oy = 0, radius = 3
	}

function Sprite:New(o)
	o = o or {}
	setmetatable(o, self)
	self.__index = self
	return o
end

function Sprite:updateCoordinates()
	self.x = 64*(self.wy-self.wx)
	self.y = 32*(self.wx+self.wy)-24*self.wz
	self.z = self.wx+self.wy
end

function Sprite:setImage(filename)
	self.img = love.graphics.newImage(filename)
	self.img:setFilter('nearest','nearest')
end


function Sprite:draw()
	
	newStencilNumber = math.max(math.floor(self.wx+0.1)+math.floor(self.wy+0.1)+3,3)
	if newStencilNumber ~= stencilNumber then
		stencilNumber = newStencilNumber
		love.graphics.setInvertedStencil(stencils[stencilNumber])
	end
	currentStencil = stencilNumber

	if self.img then
		love.graphics.draw(self.img,self.x,self.y, 0, 1, 1, self.ox, self.oy)
	end

end

function Sprite:move()
end

function Sprite:kill()
	self.dead = true
end

return Sprite
